// The tutorial will start off with some information regarding how to download AudioKit
// and create a suitable playground

// Start with a brief mention of Elisha Gray (https://en.wikipedia.org/wiki/Elisha_Gray) who
// discovered oscillators and in 1874 transmitted the first musical note

// A brief look at the basics of sound (frequency - Hertz, volume)

// Introduce the Theramin

// Throughout this commentary, the following playground will be built:


import AudioKit
import PlaygroundSupport


// create an oscillator - which is an AudioKit node
let oscillator = AKOscillator()

// set the frequency in Hertz
oscillator.frequency = 500
// set the ramp time, which causes parameters to change smoothly
oscillator.rampTime = 1

// start the AudioKit 'engine'
AudioKit.output = oscillator
AudioKit.start()

// start a loop, updating the oscillator frequency
AKPlaygroundLoop(frequency: 0.5) {
  oscillator.frequency =
    oscillator.frequency == 500 ? 100 : 500
}

// and start the oscillator
oscillator.start()

PlaygroundPage.current.needsIndefiniteExecution = true
